;---------------------------------------------------------------------------]
;-- WindowsProcess Library 1.0 Demo
;-- Author      : Prof. DrAcULA
;-- Date        : 6/4/2005 1:21AM
;-- Description : Demo
;---------------------------------------------------------------------------]

.386 
.model flat, stdcall
option casemap:none

;---------------------------------------------------------------------------]
;--includes and libs for Demo
        include         \masm32\include\windows.inc
        include         \masm32\include\user32.inc
        include         \masm32\include\kernel32.inc
        include         \masm32\include\gdi32.inc
        includelib      \masm32\lib\user32.lib
        includelib      \masm32\lib\kernel32.lib
        includelib      \masm32\lib\gdi32.lib

        include         lib\windowsprocess.inc
        includelib      lib\windowsprocess.lib
;---------------------------------------------------------------------------]


;---------------------------------------------------------------------------]
;--local function prototypes
        WndProc         PROTO   :DWORD, :DWORD, :DWORD, :DWORD
;---------------------------------------------------------------------------]


.DATA
;---------------------------------------------------------------------------]
;--initialized data
        szFilter        DB      "Number of active processes: %s",0      ;--filter string for wsprintf
;---------------------------------------------------------------------------]

        
.DATA?
;---------------------------------------------------------------------------]
;--uninitialized data
Buffer                  DB              100 DUP(?)      ;--for output on static
Result                  DB              ?               ;--for storing number-of-processes
hInstance               DD              ?               ;--for application handle
hDlg                    DD              ?               ;--for dialog handle
hList                   DD              ?               ;--for listbox handle
hStatic                 DD              ?               ;--for static
ExitCode                DD              ?               ;--for GTHOOH
;---------------------------------------------------------------------------]


.CONST
;---------------------------------------------------------------------------]
;--resources
        ID_ICON                 EQU             500     ;--Icon
        ID_DIALOG               EQU             100     ;--Dialog
        ID_PROCESSES            EQU             103     ;--Listbox
        ID_REFRESH              EQU             104     ;--Refresh button
        ID_EXIT                 EQU             105     ;--Exit button
        ID_RESULT               EQU             106     ;--Static
        ID_KILL                 EQU             107     ;--Kill button
;---------------------------------------------------------------------------]


.CODE
;---------------------------------------------------------------------------]
;--execution starts here
START:
        invoke  GetModuleHandle, 0                                      ;--get app handle
        mov     hInstance, eax                                          ;--and store it in hInstance
        invoke  DialogBoxParam, eax, ID_DIALOG, 0, offset WndProc, 0    ;--show window
        invoke  ExitProcess, eax                                        ;--close the app
;---------------------------------------------------------------------------]


;---------------------------------------------------------------------------]
;--this is the Window-procedure function of our window
WndProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
        mov     eax, uMsg               ;--get message in eax
        cmp     eax, WM_INITDIALOG      ;--if its inittialization
        jz      _INITDIALOG             ;--goto init procedure
        cmp     eax, WM_COMMAND         ;--if its COMMAND
        jz      _COMMAND                ;--goto Command-routine
        cmp     eax, WM_CLOSE           ;--if its CLOSE
        jz      _CLOSE                  ;--goto Close-routine
        
   _DEFAULT:
        xor     eax, eax                ;--clear eax
        ret                             ;--and return
        
   _CLOSE:
        invoke  EndDialog, hWnd, 0      ;--and close window
        xor     eax, eax                ;--clear eax
        ret                             ;--and return
        
   _INITDIALOG:
        invoke  LoadIcon, hInstance, ID_ICON                            ;--load icon from resource
        invoke  SendMessage, hWnd, WM_SETICON, ICON_SMALL, eax          ;--and set it
        invoke  GetDlgItem, hWnd, ID_PROCESSES                          ;--get handle to listbox
        mov     hList, eax                                              ;--and store it in hList
        invoke  GetDlgItem, hWnd, ID_RESULT                             ;--get handle to static
        mov     hStatic, eax                                            ;--and store it in hStatic
        invoke  ListProcess, hList, offset Result                       ;--call ListProcess
        invoke  wsprintf, offset Buffer, offset szFilter, offset Result ;--format number of processes
        invoke  SetWindowText, hStatic, offset Buffer                   ;--display formatted string on static
        xor     eax, eax                                                ;--clear eax
        ret                                                             ;--and return
        
   _COMMAND:
        mov     eax, wParam             ;--move wParam to eax
        cmp     ax, ID_REFRESH          ;--if Install-button was pressed
        jz      _COMMAND_REFRESH        ;--goto Install-routine
        cmp     ax, ID_KILL             ;--if Kill-button was pressed
        jz      _COMMAND_KILL           ;--goto Kill-routine
        cmp     ax, ID_EXIT             ;--if Exit-button was pressed
        jz      _CLOSE                  ;--goto Close-routine
        xor     eax, eax                ;--clear eax
        ret                             ;--and return
        
   _COMMAND_REFRESH:
        invoke  ListProcess, hList, offset Result                       ;--call ListProcess
        invoke  wsprintf, offset Buffer, offset szFilter, offset Result ;--format number of processes
        invoke  SetWindowText, hStatic, offset Buffer                   ;--display on static
        xor     eax, eax                                                ;--clear eax
        ret                                                             ;--and return
        
  _COMMAND_KILL:
        invoke  KillProcess, hList, offset Result                       ;--call KillProcess
        invoke  wsprintf, offset Buffer, offset szFilter, offset Result ;--format number of processes
        invoke  SetWindowText, hStatic, offset Buffer                   ;--display string on static
        xor     eax, eax                                                ;--clear eax
        ret                                                             ;--and return
WndProc ENDP 
;---------------------------------------------------------------------------]

END START
;---------------------------------------------------------------------------]
;-- 2005, Prof. DrAcULA : "Knowledge is the sweetest blood!"
;---------------------------------------------------------------------------]